/* Copyright (C) 2013 Benjamin Monmege 
   LSV, ENS Cachan & CNRS
   <benjamin.monmege@lsv.ens-cachan.fr>

   This program is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation, either version 3 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see
   <http://www.gnu.org/licenses/>. */

%{
  open Modules
  open Formula	
  open Expression	
%}	

%token <float> NUM
%token <char> LETTER VAR
%token OPEN_PAR CLOS_PAR
%token RIGHT LEFT PLUS CONC STAR PSTAR COMPUTE
%token BASIC TRUE BEGIN END NOT AND OR NEWLINE
%token EOF

%left PLUS
%left CONC 
%right STAR PSTAR
%left COMPUTE

%left AND OR
%right BASIC
%left NOT

%start input
%type <Modules.Expression.expression> input
  
%%

input: 
 | pexpr EOF { $1 }
  ;
  
  expr: 
 | NUM { Val $1 }
 | RIGHT { Right }
 | LEFT { Left }
 | pexpr PLUS pexpr { Plus ($1,$3) }
 | pexpr CONC pexpr { Conc ($1,$3) }
 | pexpr STAR { Star $1 }
 | pexpr PSTAR { PStar $1 }
 | VAR COMPUTE pexpr { Compute ($1,$3) }
  ;

  pexpr:
 | pform  { Form $1 }
 | expr { $1 }
 | OPEN_PAR expr CLOS_PAR { $2 }
  ;

  form: 
 | TRUE { True }
 | BEGIN { Begin }
 | END { End }
 | LETTER BASIC { Letter $1 }
 | VAR BASIC { Var $1 }
 | NOT pform { Not $2 }
 | pform AND pform { And ($1,$3) }
 | pform OR pform { Or ($1,$3) }
  ;

  pform:
 | form { $1 }
 | OPEN_PAR form CLOS_PAR { $2 }
  ;

%%
  
