(* Copyright (C) 2013 Benjamin Monmege 
   LSV, ENS Cachan & CNRS
   <benjamin.monmege@lsv.ens-cachan.fr>

   This program is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation, either version 3 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see
   <http://www.gnu.org/licenses/>. *)

open Modules
open Formula	
open Expression

let _ = 
  if Array.length Sys.argv <> 2 then begin
    print_string "Usage: expr2auto <expression>";
    print_newline()
  end else begin
    let e = Expr.input Lexer.token (Lexing.from_string Sys.argv.(1))
    in let automaton = Kleene.automaton_of_expression e
       in print_string (Automaton.gastex_print automaton 10. 10.); print_newline ()
  end


let parse_error s = (* Called by the parser function on error *)
  print_endline s;
  flush stdout
