(* Copyright (C) 2013 Benjamin Monmege 
   LSV, ENS Cachan & CNRS
   <benjamin.monmege@lsv.ens-cachan.fr>

   This program is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation, either version 3 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see
   <http://www.gnu.org/licenses/>. *)


{
  open Modules
  open Formula
  open Expression
  open Expr (* expr.mly *)
}

let letter = ['a'-'w']
let variable = ['x'-'z']
let weight = ['0'-'9']*'.'['0'-'9']+ | ['0'-'9']+'.'['0'-'9']*
  
rule token = parse
  | weight as s { NUM (float_of_string s) }
  | "->" { RIGHT }
  | "<-" { LEFT }
  | "+" { PLUS }
  | "." { CONC }
  | "^*" { STAR }
  | "^+" { PSTAR }
  | "!" { COMPUTE }
  | letter as a { LETTER a }
  | "?" { BASIC }
  | "top" { TRUE }
  | "begin" { BEGIN }
  | "end" { END }
  | "not" { NOT }
  | "and" { AND }
  | "or" { OR }
  | variable as x { VAR x }
  | "\n" { NEWLINE }
  | "(" { OPEN_PAR }
  | ")" { CLOS_PAR }
  | _ { token lexbuf }
  | eof	{ EOF }

